/*
 * Copyright (c) 2012-2017 Andes Technology Corporation
 * All rights reserved.
 *
 */

#ifndef __PLATFORM_H__
#define __PLATFORM_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "config.h"
#include "nds32_defs.h"
#include "ae3xx.h"
#include "uart.h"
#include "timer.h"
#include "gpio.h"

#define CFG_AE3XX

/*****************************************************************************
 * Platfrom vector base
 ****************************************************************************/
#ifdef CFG_XIP
#define VECTOR_BASE          0x80000000
#else
#define VECTOR_BASE          0x00000000
#endif

/*****************************************************************************
 * Peripheral device HAL declaration
 ****************************************************************************/
#define DEV_UART1            AE3XX_UART1
#define DEV_UART2            AE3XX_UART2
#define DEV_PIT              AE3XX_PIT
#define DEV_GPIO             AE3XX_GPIO

/*****************************************************************************
 * Timer HAL declaration
 ****************************************************************************/
#define IRQ_TIMER1_VECTOR    IRQ_PIT_VECTOR
#define timer_irq_handler    pit_irq_handler

/*****************************************************************************
 * Board specified
 ****************************************************************************/
#define GPIO_USED_GCOV       0x02    /* Which GPIO to do GCOV */
#define GPIO_USED_MASK       0x7F    /* Which GPIOs to use */

#ifdef __cplusplus
}
#endif

#endif	/* __PLATFORM_H__ */
